<template as="div">
    <div class="flex justify-between items-center">
      <h2 class="font-mm font-bold text-primary">
        <fa-icon class="mr-1" icon="fa-solid fa-diagram-predecessor" />
       Sub-Term Block Collaterral 
      </h2>
      <div  class="space-x-[10px] flex items-center">
        <el-button :disabled="hasInvalid()" v-if="PaymentDetails > 0" @click="onSaveAll()"
          class="bg-primary hover:bg-primary-80 rounded-full" size="large" color="#16a34a">
          Save All({{ PaymentDetails }})
        </el-button>
        <el-button @click="addNewRow()" class="bg-green-600 hover:bg-green-700 rounded-full" size="default"
          color="#16a34a">
          <fa-icon icon="fa-solid fa-plus" />
        </el-button>
      </div>
    </div>
    <div class="overflow-x-auto relative mt-4 cus" v-loading="localLoading">
      <table class="w-full text-sm text-left text-gray-500">
        <thead class="text-primary font-bold uppercase bg-gray-50">
          <tr>
            <th scope="col" class="py-3 px-2 w-60 text-center">Schedule Date</th>
            <th scope="col" class="py-3 px-2 w-50 text-center">Amount Kh</th>
            <th scope="col" class="py-3 px-2 w-40 text-center">Amount Usd</th>
            <th v-if="!isReadOnly" scope="col" class="py-3 px-2 w-40 text-center">
              Action 
            </th>
          </tr>
        </thead>
  
        <template v-if="subtermList.length > 0">
          <!-- tbody -->
          <Form as="tbody" v-slot="{ handleSubmit, meta }" v-for="(data, j) in subtermList" :key="j" class="bg-white"
            :class="{ 'bg-gray-50': (j + 1) % 2 == 0 }">
            <th scope="row" class="font-medium text-gray-900 whitespace-nowrap text-center">
              <Field v-if="data?.allowEdit" v-slot="{ value, handleChange, errorMessage }" rules="required"
                name="scheduleDate" v-model="data.scheduleDate" class="rounded-none" as="div">
                <el-form-item :error="errorMessage">
                  <el-date-picker @keyup.enter="handleSubmit($event, onSaveOne(data, meta, j))" :model-value="value"
                    @update:model-value="handleChange" size="large" style="width: 100%" type="date"
                    placeholder="select schedule date" value-format="YYYY-MM-DD" format="DD/MM/YYYY" />
                </el-form-item>
              </Field>
              <div class="p-2" v-else>
                {{ $dayjs(data?.scheduleDate).format("DD/MM/YYYY") }}
              </div>
            </th>
            <th scope="row" class="font-medium text-gray-900 whitespace-nowrap text-center">
              <Field v-if="data?.allowEdit" v-slot="{ value, errorMessage, handleChange }" rules="required"
                name="amountKh" v-model="data.amountKh" class="rounded-none" as="div">
                <el-form-item :error="errorMessage">
                  <el-input @keyup.enter="handleSubmit($event, onSaveOne(data, meta, j))" :validate-event="false"
                    type="number" class="w-full" :model-value="value" @update:model-value="handleChange"
                    placeholder="Amount Kh" />
                </el-form-item>
              </Field>
              <div class="p-2" v-else>{{ data?.amountKh }}</div>
            </th>
            <th scope="row" class="font-medium text-gray-900 whitespace-nowrap text-center">
              <Field v-if="data?.allowEdit" v-slot="{ value, errorMessage, handleChange }" rules="required"
                name="amountUsd" v-model="data.amountUsd" class="rounded-none" as="div">
                <el-form-item :error="errorMessage">
                  <el-input @keyup.enter="handleSubmit($event, onSaveOne(data, meta, j))" :validate-event="false"
                    type="number" :model-value="value" @update:model-value="handleChange" placeholder="Amount Usd" />
                </el-form-item>
              </Field>
              <div v-html="$format(data?.amountUsd)" v-else></div>
            </th>
            <th v-if="!isReadOnly" scope="row" class="px-2 font-medium text-gray-900 whitespace-nowrap text-center">
              <div v-if="!data.paidAt">
                <div v-if="data.allowEdit" class="flex space-x-2 justify-center">
                  <el-button @click="handleSubmit($event, onSaveOne(data, meta, j))" class=" bg-blue-700  hover:bg-blue-600  rounded-full  ml-2  px-3  py-4
                  " size="default" color="#1d4ed8">
                    <fa-icon icon="fa-solid fa-save" />
                  </el-button>
                  <el-button @click="onCancel(j, data)" class="bg-orange-300  hover:bg-orange-200  rounded-full ml-2 px-3 py-4 " size="default" color="#fdba74">
                    <fa-icon icon="fa-solid fa-cancel" />
                  </el-button>
                </div>
                <div v-else class="flex space-x-2 justify-center">
                  <button v-if="!data?.paidAt" @click="onEdit(data)" type="button" class="  text-white  bg-yellow-600 hover:bg-yellow-700  focus:outline-none focus:ring-4 focus:ring-red-300  font-medium rounded-full  text-sm px-3  py-2 text-center ">
                    <fa-icon icon="fa-solid fa-pen-to-square" />
                  </button>
                  <button v-if="!data?.paidAt" @click="onDelete(j, data?.id)" type="button" class="  text-white  bg-red-700 hover:bg-red-800  focus:outline-none focus:ring-4 focus:ring-red-300 font-medium  rounded-full  text-sm  px-3  py-2  text-center ">
                    <fa-icon icon="fa-solid fa-trash-can" />
                  </button>
                </div>
              </div>
              <div class="flex space-x-2 justify-center" v-else>
                {{ $dayjs(data?.paidAt).format('DD/MMM/YYYY') }}
              </div>
            </th>
          </Form>
        </template>
        <tbody v-else>
          <tr class="bg-white ">
            <th scope="row" colspan="100%" class="  py-4  px-6  font-medium  text-center text-gray-900  whitespace-nowrap">
              No Data
            </th>
          </tr>
        </tbody>
      </table>
    </div>
  </template>
  
  <script>
  import { delay } from "@/helpers";
  import { computed, ref } from "vue";
  import {  useStore } from "vuex";
  import { Field, Form } from "vee-validate";
  
  export default {
    name: "VAddItems",
    components: { Form, Field },
    props: {
      data: {
        type: Object,
        default: () => ({}),
      },
    },
    created() {
      this.fetchAll();
    },
    data: () => ({
      file: null,
      localLoading: false,
    }),
    methods: {
      addNewRow() {
      const newList = [
        ...this.subtermList,
        ...[
          {
            allowEdit: true,
            scheduleDate: "",
            amountKh: "",
            amountUsd: "",
          },
        ],
      ];

      this.setDetails(newList);
    },

    },
    setup(props) {
      const store = useStore();
      const showModal = ref(false);
      const loading = ref(false);
      const loadingText = ref("");
  
      const fetchAll = () => {
        store.dispatch("BlockCollateral/fetchBlockCollateral", props?.data?.id);
      };
  
      const isSubLoading = computed(
        () => store.state["BlockCollateral"].isSubLoading
      );
      const subtermList = computed(
        () => store.state["BlockCollateral"]?.details || []
      );
  
      const PaymentDetails = computed(() => {
        return (store.state["BlockCollateral"]?.details || []).filter(
          (o) => o.allowEdit
        ).length;
      });
  
      const onSaveOne = async (values, meta, index) => {
        if (meta.valid) {
          values.schedulePaymentId = props?.data?.id;
          values.index = index;
          if (!values.id) {
            await store.dispatch("BlockCollateral/addBlockCollateral", values);
          } else {
            await store.dispatch("BlockCollateral/updateBlockCollateral", values);
          }
        }
      };
  
      const onSaveAll = async () => {
        loading.value = true;
        let count = 0;
        loadingText.value = `${count} successful!`;
        for (let i in subtermList.value || []) {
          const data = subtermList.value[i];
          if (data.allowEdit) {
            data.schedulePaymentId = props?.data?.id;
            data.index = i;
            await delay(200);
            if (!data.id) {
              await store.dispatch("BlockCollateral/addBlockCollateral", data);
              count++;
              loadingText.value = `${count} successful!`;
            } else {
              await store.dispatch("BlockCollateral/updateBlockCollateral", data);
            }
          }
        }
        loading.value = false;
      };
  
      const isReadOnly = computed(() => {
        return props?.data?.recStatus > 0;
      });
  
      const onDelete = async (index, id) => {
        if (id) {
          store.dispatch("BlockCollateral/deleteBlockCollateral", { id, index });
        }
      };
  
      const Details = computed(() => {
        return [...(store.state["BlockCollateral"]?.details || [])];
      });
  
      return {
        isSubLoading,
        showModal,
        isReadOnly,
        subtermList,
        onSaveOne,
        onSaveAll,
        PaymentDetails,
        fetchAll,
        onDelete,
        Details
      };
    },
  };
  </script>
  
  <style lang="scss" scoped>
  table,
  th,
  td {
    border: 1px solid #ddd;
    border-collapse: collapse;
  }
  
  tbody:nth-child(odd) {
    background-color: #edeeef !important;
  }
  </style>